# mypy-boto3-pinpoint

[![PyPI - mypy-boto3-pinpoint](https://img.shields.io/pypi/v/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-pinpoint.svg?color=blue)](https://pypi.org/project/mypy-boto3-pinpoint)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-pinpoint?color=blue)](https://pypistats.org/packages/mypy-boto3-pinpoint)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.Pinpoint 1.17.56](https://boto3.amazonaws.com/v1/documentation/api/1.17.56/reference/services/pinpoint.html#Pinpoint) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.6.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-pinpoint](#mypy-boto3-pinpoint)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `Pinpoint` service.

```bash
python -m pip install boto3-stubs[pinpoint]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[pinpoint]` in your environment: `python -m pip install 'boto3-stubs[pinpoint]'`

Both type checking and auto-complete should work for `Pinpoint` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[pinpoint]` in your environment: `python -m pip install 'boto3-stubs[pinpoint]'`

Both type checking and auto-complete should work for `Pinpoint` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[pinpoint]` in your environment: `python -m pip install 'boto3-stubs[pinpoint]'`
- Run `mypy` as usual

Type checking should work for `Pinpoint` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[pinpoint]` in your environment: `python -m pip install 'boto3-stubs[pinpoint]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `Pinpoint` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`PinpointClient` provides annotations for `boto3.client("pinpoint")`.

```python
import boto3

from mypy_boto3_pinpoint import PinpointClient

client: PinpointClient = boto3.client("pinpoint")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: PinpointClient = session.client("pinpoint")
```








### Typed dictionations

`mypy_boto3_pinpoint.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_pinpoint.type_defs import (
    ADMChannelResponseTypeDef,
    ADMMessageTypeDef,
    APNSChannelResponseTypeDef,
    APNSMessageTypeDef,
    APNSPushNotificationTemplateTypeDef,
    APNSSandboxChannelResponseTypeDef,
    APNSVoipChannelResponseTypeDef,
    APNSVoipSandboxChannelResponseTypeDef,
    ActivitiesResponseTypeDef,
    ActivityResponseTypeDef,
    ActivityTypeDef,
    AddressConfigurationTypeDef,
    AndroidPushNotificationTemplateTypeDef,
    ApplicationDateRangeKpiResponseTypeDef,
    ApplicationResponseTypeDef,
    ApplicationSettingsResourceTypeDef,
    ApplicationsResponseTypeDef,
    AttributeDimensionTypeDef,
    AttributesResourceTypeDef,
    BaiduChannelResponseTypeDef,
    BaiduMessageTypeDef,
    BaseKpiResultTypeDef,
    CampaignCustomMessageTypeDef,
    CampaignDateRangeKpiResponseTypeDef,
    CampaignEmailMessageTypeDef,
    CampaignEventFilterTypeDef,
    CampaignHookTypeDef,
    CampaignLimitsTypeDef,
    CampaignResponseTypeDef,
    CampaignSmsMessageTypeDef,
    CampaignStateTypeDef,
    CampaignsResponseTypeDef,
    ChannelResponseTypeDef,
    ChannelsResponseTypeDef,
    ConditionTypeDef,
    ConditionalSplitActivityTypeDef,
    CreateTemplateMessageBodyTypeDef,
    CustomDeliveryConfigurationTypeDef,
    CustomMessageActivityTypeDef,
    DefaultMessageTypeDef,
    DefaultPushNotificationMessageTypeDef,
    DefaultPushNotificationTemplateTypeDef,
    DirectMessageConfigurationTypeDef,
    EmailChannelResponseTypeDef,
    EmailMessageActivityTypeDef,
    EmailMessageTypeDef,
    EmailTemplateResponseTypeDef,
    EndpointBatchItemTypeDef,
    EndpointDemographicTypeDef,
    EndpointItemResponseTypeDef,
    EndpointLocationTypeDef,
    EndpointMessageResultTypeDef,
    EndpointResponseTypeDef,
    EndpointSendConfigurationTypeDef,
    EndpointUserTypeDef,
    EndpointsResponseTypeDef,
    EventConditionTypeDef,
    EventDimensionsTypeDef,
    EventFilterTypeDef,
    EventItemResponseTypeDef,
    EventStartConditionTypeDef,
    EventStreamTypeDef,
    EventTypeDef,
    EventsBatchTypeDef,
    EventsResponseTypeDef,
    ExportJobResourceTypeDef,
    ExportJobResponseTypeDef,
    ExportJobsResponseTypeDef,
    GCMChannelResponseTypeDef,
    GCMMessageTypeDef,
    GPSCoordinatesTypeDef,
    GPSPointDimensionTypeDef,
    HoldoutActivityTypeDef,
    ImportJobResourceTypeDef,
    ImportJobResponseTypeDef,
    ImportJobsResponseTypeDef,
    ItemResponseTypeDef,
    JourneyCustomMessageTypeDef,
    JourneyDateRangeKpiResponseTypeDef,
    JourneyEmailMessageTypeDef,
    JourneyExecutionActivityMetricsResponseTypeDef,
    JourneyExecutionMetricsResponseTypeDef,
    JourneyLimitsTypeDef,
    JourneyPushMessageTypeDef,
    JourneyResponseTypeDef,
    JourneySMSMessageTypeDef,
    JourneyScheduleTypeDef,
    JourneysResponseTypeDef,
    ListRecommenderConfigurationsResponseTypeDef,
    MessageBodyTypeDef,
    MessageConfigurationTypeDef,
    MessageResponseTypeDef,
    MessageResultTypeDef,
    MessageTypeDef,
    MetricDimensionTypeDef,
    MultiConditionalBranchTypeDef,
    MultiConditionalSplitActivityTypeDef,
    NumberValidateResponseTypeDef,
    PublicEndpointTypeDef,
    PushMessageActivityTypeDef,
    PushNotificationTemplateResponseTypeDef,
    QuietTimeTypeDef,
    RandomSplitActivityTypeDef,
    RandomSplitEntryTypeDef,
    RawEmailTypeDef,
    RecencyDimensionTypeDef,
    RecommenderConfigurationResponseTypeDef,
    ResultRowTypeDef,
    ResultRowValueTypeDef,
    SMSChannelResponseTypeDef,
    SMSMessageActivityTypeDef,
    SMSMessageTypeDef,
    SMSTemplateResponseTypeDef,
    ScheduleTypeDef,
    SegmentBehaviorsTypeDef,
    SegmentConditionTypeDef,
    SegmentDemographicsTypeDef,
    SegmentDimensionsTypeDef,
    SegmentGroupListTypeDef,
    SegmentGroupTypeDef,
    SegmentImportResourceTypeDef,
    SegmentLocationTypeDef,
    SegmentReferenceTypeDef,
    SegmentResponseTypeDef,
    SegmentsResponseTypeDef,
    SendUsersMessageResponseTypeDef,
    SessionTypeDef,
    SetDimensionTypeDef,
    SimpleConditionTypeDef,
    SimpleEmailPartTypeDef,
    SimpleEmailTypeDef,
    StartConditionTypeDef,
    TagsModelTypeDef,
    TemplateConfigurationTypeDef,
    TemplateResponseTypeDef,
    TemplateTypeDef,
    TemplateVersionResponseTypeDef,
    TemplateVersionsResponseTypeDef,
    TemplatesResponseTypeDef,
    TreatmentResourceTypeDef,
    VoiceChannelResponseTypeDef,
    VoiceMessageTypeDef,
    VoiceTemplateResponseTypeDef,
    WaitActivityTypeDef,
    WaitTimeTypeDef,
    WriteTreatmentResourceTypeDef,
    ADMChannelRequestTypeDef,
    APNSChannelRequestTypeDef,
    APNSSandboxChannelRequestTypeDef,
    APNSVoipChannelRequestTypeDef,
    APNSVoipSandboxChannelRequestTypeDef,
    BaiduChannelRequestTypeDef,
    CreateAppResponseTypeDef,
    CreateApplicationRequestTypeDef,
    CreateCampaignResponseTypeDef,
    CreateEmailTemplateResponseTypeDef,
    CreateExportJobResponseTypeDef,
    CreateImportJobResponseTypeDef,
    CreateJourneyResponseTypeDef,
    CreatePushTemplateResponseTypeDef,
    CreateRecommenderConfigurationResponseTypeDef,
    CreateRecommenderConfigurationTypeDef,
    CreateSegmentResponseTypeDef,
    CreateSmsTemplateResponseTypeDef,
    CreateVoiceTemplateResponseTypeDef,
    DeleteAdmChannelResponseTypeDef,
    DeleteApnsChannelResponseTypeDef,
    DeleteApnsSandboxChannelResponseTypeDef,
    DeleteApnsVoipChannelResponseTypeDef,
    DeleteApnsVoipSandboxChannelResponseTypeDef,
    DeleteAppResponseTypeDef,
    DeleteBaiduChannelResponseTypeDef,
    DeleteCampaignResponseTypeDef,
    DeleteEmailChannelResponseTypeDef,
    DeleteEmailTemplateResponseTypeDef,
    DeleteEndpointResponseTypeDef,
    DeleteEventStreamResponseTypeDef,
    DeleteGcmChannelResponseTypeDef,
    DeleteJourneyResponseTypeDef,
    DeletePushTemplateResponseTypeDef,
    DeleteRecommenderConfigurationResponseTypeDef,
    DeleteSegmentResponseTypeDef,
    DeleteSmsChannelResponseTypeDef,
    DeleteSmsTemplateResponseTypeDef,
    DeleteUserEndpointsResponseTypeDef,
    DeleteVoiceChannelResponseTypeDef,
    DeleteVoiceTemplateResponseTypeDef,
    EmailChannelRequestTypeDef,
    EmailTemplateRequestTypeDef,
    EndpointBatchRequestTypeDef,
    EndpointRequestTypeDef,
    EventsRequestTypeDef,
    ExportJobRequestTypeDef,
    GCMChannelRequestTypeDef,
    GetAdmChannelResponseTypeDef,
    GetApnsChannelResponseTypeDef,
    GetApnsSandboxChannelResponseTypeDef,
    GetApnsVoipChannelResponseTypeDef,
    GetApnsVoipSandboxChannelResponseTypeDef,
    GetAppResponseTypeDef,
    GetApplicationDateRangeKpiResponseTypeDef,
    GetApplicationSettingsResponseTypeDef,
    GetAppsResponseTypeDef,
    GetBaiduChannelResponseTypeDef,
    GetCampaignActivitiesResponseTypeDef,
    GetCampaignDateRangeKpiResponseTypeDef,
    GetCampaignResponseTypeDef,
    GetCampaignVersionResponseTypeDef,
    GetCampaignVersionsResponseTypeDef,
    GetCampaignsResponseTypeDef,
    GetChannelsResponseTypeDef,
    GetEmailChannelResponseTypeDef,
    GetEmailTemplateResponseTypeDef,
    GetEndpointResponseTypeDef,
    GetEventStreamResponseTypeDef,
    GetExportJobResponseTypeDef,
    GetExportJobsResponseTypeDef,
    GetGcmChannelResponseTypeDef,
    GetImportJobResponseTypeDef,
    GetImportJobsResponseTypeDef,
    GetJourneyDateRangeKpiResponseTypeDef,
    GetJourneyExecutionActivityMetricsResponseTypeDef,
    GetJourneyExecutionMetricsResponseTypeDef,
    GetJourneyResponseTypeDef,
    GetPushTemplateResponseTypeDef,
    GetRecommenderConfigurationResponseTypeDef,
    GetRecommenderConfigurationsResponseTypeDef,
    GetSegmentExportJobsResponseTypeDef,
    GetSegmentImportJobsResponseTypeDef,
    GetSegmentResponseTypeDef,
    GetSegmentVersionResponseTypeDef,
    GetSegmentVersionsResponseTypeDef,
    GetSegmentsResponseTypeDef,
    GetSmsChannelResponseTypeDef,
    GetSmsTemplateResponseTypeDef,
    GetUserEndpointsResponseTypeDef,
    GetVoiceChannelResponseTypeDef,
    GetVoiceTemplateResponseTypeDef,
    ImportJobRequestTypeDef,
    JourneyStateRequestTypeDef,
    ListJourneysResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListTemplateVersionsResponseTypeDef,
    ListTemplatesResponseTypeDef,
    MessageRequestTypeDef,
    NumberValidateRequestTypeDef,
    PhoneNumberValidateResponseTypeDef,
    PushNotificationTemplateRequestTypeDef,
    PutEventStreamResponseTypeDef,
    PutEventsResponseTypeDef,
    RemoveAttributesResponseTypeDef,
    SMSChannelRequestTypeDef,
    SMSTemplateRequestTypeDef,
    SendMessagesResponseTypeDef,
    SendUsersMessageRequestTypeDef,
    SendUsersMessagesResponseTypeDef,
    TemplateActiveVersionRequestTypeDef,
    UpdateAdmChannelResponseTypeDef,
    UpdateApnsChannelResponseTypeDef,
    UpdateApnsSandboxChannelResponseTypeDef,
    UpdateApnsVoipChannelResponseTypeDef,
    UpdateApnsVoipSandboxChannelResponseTypeDef,
    UpdateApplicationSettingsResponseTypeDef,
    UpdateAttributesRequestTypeDef,
    UpdateBaiduChannelResponseTypeDef,
    UpdateCampaignResponseTypeDef,
    UpdateEmailChannelResponseTypeDef,
    UpdateEmailTemplateResponseTypeDef,
    UpdateEndpointResponseTypeDef,
    UpdateEndpointsBatchResponseTypeDef,
    UpdateGcmChannelResponseTypeDef,
    UpdateJourneyResponseTypeDef,
    UpdateJourneyStateResponseTypeDef,
    UpdatePushTemplateResponseTypeDef,
    UpdateRecommenderConfigurationResponseTypeDef,
    UpdateRecommenderConfigurationTypeDef,
    UpdateSegmentResponseTypeDef,
    UpdateSmsChannelResponseTypeDef,
    UpdateSmsTemplateResponseTypeDef,
    UpdateTemplateActiveVersionResponseTypeDef,
    UpdateVoiceChannelResponseTypeDef,
    UpdateVoiceTemplateResponseTypeDef,
    VoiceChannelRequestTypeDef,
    VoiceTemplateRequestTypeDef,
    WriteApplicationSettingsRequestTypeDef,
    WriteCampaignRequestTypeDef,
    WriteEventStreamTypeDef,
    WriteJourneyRequestTypeDef,
    WriteSegmentRequestTypeDef,
)

def get_structure() -> ADMChannelResponseTypeDef:
    return {
      ...
    }
```
